; Demonstrates how to use rebars

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#Include <GuiEdit.au3>
#Include <GuiListView.au3>


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


;- Control Constants
Enum $MENU_0, $MENU_1, $REBAR_0, $PopupMenu_0, $TOOLBAR_0

; Define some global arrays for easy access of icon images
Global $imageNormal[37]
Global $imageHot[37]
Global $imageDisabled[37]

; load in some example icons
$imagenormal[0] = LoadImg("icons\cut.ico", 16, 16, 0)
$imagehot[0] = LoadImg("icons\cut_h.ico", 16, 16, 0)
$imagedisabled[0] = LoadImg("icons\cut_d.ico", 16, 16, 0)

$imagenormal[1] = LoadImg("icons\paste.ico", 16, 16, 0)
$imagehot[1] = LoadImg("icons\paste_h.ico", 16, 16, 0)
$imagedisabled[1] = LoadImg("icons\paste_d.ico", 16, 16, 0)

$imagenormal[2] = LoadImg("icons\image.ico", 16, 16, 0)
$imagehot[2] = LoadImg("icons\image_h.ico", 16, 16, 0)
$imagedisabled[2] = LoadImg("icons\image_d.ico", 16, 16, 0)

$imagenormal[3] = LoadImg("icons\multimedia.ico", 16, 16, 0)
$imagehot[3] = LoadImg("icons\multimedia_h.ico", 16, 16, 0)
$imagedisabled[3] = LoadImg("icons\multimedia_d.ico", 16, 16, 0)

$imagenormal[4] = LoadImg("icons\package.ico", 16, 16, 0)
$imagehot[4] = LoadImg("icons\package_h.ico", 16, 16, 0)
$imagedisabled[4] = LoadImg("icons\package_d.ico", 16, 16, 0)

$imagenormal[5] = LoadImg("icons\preferences.ico", 16, 16, 0)
$imagehot[5] = LoadImg("icons\preferences_h.ico", 16, 16, 0)
$imagedisabled[5] = LoadImg("icons\preferences_d.ico", 16, 16, 0)

$imagenormal[6] = LoadImg("icons\jump.ico", 16, 16, 0)
$imagehot[6] = LoadImg("icons\jump_h.ico", 16, 16, 0)
$imagedisabled[6] = LoadImg("icons\jump_d.ico", 16, 16, 0)

$imagenormal[19] = LoadImg("icons\copy doc.ico", 32, 32, 0)
$imagehot[19] = LoadImg("icons\copy doc_h.ico", 32, 32, 0)
$imagedisabled[19] = LoadImg("icons\copy doc_d.ico", 32, 32, 0)

$imagenormal[20] = LoadImg("icons\computer on.ico", 32, 32, 0)
$imagehot[20] = LoadImg("icons\computer on_h.ico", 32, 32, 0)
$imagedisabled[20] = LoadImg("icons\computer on_d.ico", 32, 32, 0)

$imagenormal[21] = LoadImg("icons\search.ico", 32, 32, 0)
$imagehot[21] = LoadImg("icons\search_h.ico", 32, 32, 0)
$imagedisabled[21] = LoadImg("icons\search_d.ico", 32, 32, 0)

$imagenormal[7] = LoadImg("icons\advanced.ico", 32, 32, 0)
$imagehot[7] = LoadImg("icons\advanced_h.ico", 32, 32, 0)
$imagedisabled[7] = LoadImg("icons\advanced_d.ico", 32, 32, 0)

$imagenormal[8] = LoadImg("icons\back_alt.ico", 32, 32, 0)
$imagehot[8] = LoadImg("icons\back_alt_h.ico", 32, 32, 0)
$imagedisabled[8] = LoadImg("icons\back_alt_d.ico", 32, 32, 0)

$imagenormal[9] = LoadImg("icons\color.ico", 32, 32, 0)
$imagehot[9] = LoadImg("icons\color_h.ico", 32, 32, 0)
$imagedisabled[9] = LoadImg("icons\color_d.ico", 32, 32, 0)

$imagenormal[10] = LoadImg("icons\computer on.ico", 32, 32, 0)
$imagehot[10] = LoadImg("icons\computer on_h.ico", 32, 32, 0)
$imagedisabled[10] = LoadImg("icons\computer on_d.ico", 32, 32, 0)

$imagenormal[11] = LoadImg("icons\copy doc.ico", 32, 32, 0)
$imagehot[11] = LoadImg("icons\copy doc_h.ico", 32, 32, 0)
$imagedisabled[11] = LoadImg("icons\copy doc_d.ico", 32, 32, 0)

$imagenormal[12] = LoadImg("icons\movies.ico", 32, 32, 0)
$imagehot[12] = LoadImg("icons\movies_h.ico", 32, 32, 0)
$imagedisabled[12] = LoadImg("icons\movies_d.ico", 32, 32, 0)

$imagenormal[13] = LoadImg("icons\new archive.ico", 32, 32, 0)
$imagehot[13] = LoadImg("icons\new archive_h.ico", 32, 32, 0)
$imagedisabled[13] = LoadImg("icons\new archive_d.ico", 32, 32, 0)

$imagenormal[14] = LoadImg("icons\new doc.ico", 32, 32, 0)
$imagehot[14] = LoadImg("icons\new doc_h.ico", 32, 32, 0)
$imagedisabled[14] = LoadImg("icons\new doc_d.ico", 32, 32, 0)

$imagenormal[15] = LoadImg("icons\refresh.ico", 32, 32, 0)
$imagehot[15] = LoadImg("icons\refresh_h.ico", 32, 32, 0)
$imagedisabled[15] = LoadImg("icons\refresh_d.ico", 32, 32, 0)

$imagenormal[16] = LoadImg("icons\search.ico", 32, 32, 0)
$imagehot[16] = LoadImg("icons\search_h.ico", 32, 32, 0)
$imagedisabled[16] = LoadImg("icons\search_d.ico", 32, 32, 0)

$imagenormal[17] = LoadImg("icons\stop.ico", 32, 32, 0)
$imagehot[17] = LoadImg("icons\stop_h.ico", 32, 32, 0)
$imagedisabled[17] = LoadImg("icons\stop_d.ico", 32, 32, 0)

$imagenormal[18] = LoadImg("icons\music 2.ico", 32, 32, 0)
$imagehot[18] = LoadImg("icons\music 2_h.ico", 32, 32, 0)
$imagedisabled[18] = LoadImg("icons\music 2_d.ico", 32, 32, 0)

;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of menu items And $toolbar items
    Case $message = $WM_COMMAND

      If Hword($wParam) = 0 Then ; is an ID Then

        $MenuID = LWord($wParam)

        ConsoleWrite($MenuID&@CRLF) ; display selected item ID

      EndIf

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  Global $Window_0 = GUICreate("RebarExample 2", 800, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  ; sub menu
  CreatePopupMenuEx($MENU_1, $UISTYLE_WHIDBEY)
  MenuItemEx(0, "Submenu Item 0", $imagenormal[6], $imagehot[6], $imagedisabled[6], 0)

  ; main menu
  $menu = CreateMenuEx($MENU_0, $Window_0, $UISTYLE_WHIDBEY)
  MenuTitleEx("Example Title &1")
  MenuItemEx(1, "&Item 1$\bCtrl+C", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
  MenuItemEx(20, "Item &2 Disabled", $imagenormal[0], $imagehot[0], $imagedisabled[0], 0)
  DisableMenuItemEx($MENU_0, 2, 1)
  MenuTitleEx("Example Title &2")
  MenuItemEx(3, "&Item 3", $imagenormal[1], $imagehot[1], $imagedisabled[1], MenuExID($MENU_1))
  MenuItemEx(4, "Item &4$\bCtrl+S", $imagenormal[2], $imagehot[2], $imagedisabled[2], 0)
  MenuItemEx(11, "Item &11 (no icon)", 0, 0, 0, 0)
  MenuBarEx()
  MenuItemEx(5, "&\i\c0000a0&Item 5\n$\bCtrl+B", $imagenormal[3], $imagehot[3], $imagedisabled[3], 0)
  MenuTitleEx("Example Title &3")
  MenuItemEx(6, "&Item 6", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
  MenuItemEx(7, "Item &7", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)
  SetMenuExImageSize(32, 32)
  MenuTitleEx("&Big Icons")
  MenuItemEx(8, "&Item 8", $imagenormal[19], $imagehot[19], $imagedisabled[19], 0)
  MenuItemEx(9, "Item &9$\bCtrl+X", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
  MenuItemEx(10, "Item &10", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  ; create popupmenu
  SetMenuExImageSize(32, 32)
  $popupmenu = CreatePopupMenuEx($PopupMenu_0, $UISTYLE_WHIDBEY)
  MenuItemEx($PopupMenu_0, "Submenu Item 1", $imagenormal[20], $imagehot[20], $imagedisabled[20], 0)
  MenuItemEx($PopupMenu_0, "Submenu Item 2", $imagenormal[21], $imagehot[21], $imagedisabled[21], 0)

  ; create toolbar
  $toolbar = CreateToolBarEx($TOOLBAR_0, $Window_0, 32, 32, $TBSTYLE_HIDECLIPPEDBUTTONS)

  ToolBarImageButtonEx(0, "Preferences", $imagenormal[7], $imagehot[7], $imagedisabled[7], BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  SelectToolbarExButton($TOOLBAR_0, 0, 1)
  ToolBarImageButtonEx(20, "Back", $imagenormal[8], $imagehot[8], $imagedisabled[8], BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  ToolBarImageButtonEx(3, "Colours", $imagenormal[9], $imagehot[9], $imagedisabled[9], BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  ToolBarImageButtonEx(4, "", 0, 0, 0, $BTNS_SEP)
  ToolBarImageButtonEx(5, "Computer", $imagenormal[10], $imagehot[10], $imagedisabled[10], $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(6, "Copy Document", $imagenormal[11], $imagehot[11], $imagedisabled[11], $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(7, "Movies", $imagenormal[12], $imagehot[12], $imagedisabled[12], $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(8, "Archive", $imagenormal[13], $imagehot[13], $imagedisabled[13], $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(9, "New Document", $imagenormal[14], $imagehot[14], $imagedisabled[14], $BTNS_AUTOSIZE)
  ToolBarDropdownImageButtonEx(10, $popupmenu, "Refresh", $imagenormal[15], $imagehot[15], $imagedisabled[15], BitOR($BTNS_AUTOSIZE, $BTNS_WHOLEDROPDOWN))
  ToolBarImageButtonEx(11, "", 0, 0, 0, $BTNS_SEP)
  ToolBarImageButtonEx(12, "Search", $imagenormal[16], $imagehot[16], $imagedisabled[16], BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarImageButtonEx(13, "Stop", $imagenormal[17], $imagehot[17], $imagedisabled[17], $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(14, "Music", $imagenormal[18], $imagehot[18], $imagedisabled[18], $BTNS_AUTOSIZE)

  DisableToolbarExButton($TOOLBAR_0, 6, 1)
  DisableToolbarExButton($TOOLBAR_0, 7, 1)

  $stringgad = _GUICtrlEdit_Create($Window_0, "String Gadget", 0, 0, 0, 0, 0)

  ; create a rebar
  CreateRebar($REBAR_0, $Window_0, 0, BitOR($RBS_VARHEIGHT, $RBS_BANDBORDERS), 0)

  AddRebarGadget($menu, "", 0, 0, 0, 0, BitOR($RBBS_BREAK, $RBBS_NOGRIPPER, $RBBS_CHILDEDGE))
  AddRebarGadget($toolbar, "", 620, 0, 0, 0, BitOR($RBBS_BREAK, $RBBS_CHILDEDGE, $RBBS_USECHEVRON))
  AddRebarGadget($stringgad, "", 620, 0, 20, 0, BitOR($RBBS_BREAK, $RBBS_CHILDEDGE))
  $listview = _GUICtrlListView_Create($Window_0, "List Icon Gadget", 0, 0, 0, 200)
  AddRebarGadget($listview, "", 0, 0, 0, 0, BitOR($RBBS_BREAK, $RBBS_CHILDEDGE))

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
  GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
  GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc


Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE

