; Demonstrates how to use ToolBarEx's

Global $Use64BitProGUI = False	; Use 64bit version of ProGUI (True/False)
#include <ProGUI_AutoIt.au3>
#include <GUIConstantsEx.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>


StartProGUI("", 0, 0, 0, 0, 0, 0, 0)


;- Control Constants
Enum $TOOLBAR_0, $PopupMenu_0

; Define some global arrays for easy access of icon images
Global $imageNormal[13]
Global $imageHot[13]
Global $imageDisabled[13]

; load in some example icons
$imagenormal[0] = LoadImg("icons\advanced.ico", 32, 32, 0)
$imagehot[0] = LoadImg("icons\advanced_h.ico", 32, 32, 0)
$imagedisabled[0] = LoadImg("icons\advanced_d.ico", 32, 32, 0)

$imagenormal[1] = LoadImg("icons\back_alt.ico", 32, 32, 0)
$imagehot[1] = LoadImg("icons\back_alt_h.ico", 32, 32, 0)
$imagedisabled[1] = LoadImg("icons\back_alt_d.ico", 32, 32, 0)

$imagenormal[2] = LoadImg("icons\color.ico", 32, 32, 0)
$imagehot[2] = LoadImg("icons\color_h.ico", 32, 32, 0)
$imagedisabled[2] = LoadImg("icons\color_d.ico", 32, 32, 0)

$imagenormal[3] = LoadImg("icons\computer on.ico", 32, 32, 0)
$imagehot[3] = LoadImg("icons\computer on_h.ico", 32, 32, 0)
$imagedisabled[3] = LoadImg("icons\computer on_d.ico", 32, 32, 0)

$imagenormal[4] = LoadImg("icons\copy doc.ico", 32, 32, 0)
$imagehot[4] = LoadImg("icons\copy doc_h.ico", 32, 32, 0)
$imagedisabled[4] = LoadImg("icons\copy doc_d.ico", 32, 32, 0)

$imagenormal[5] = LoadImg("icons\movies.ico", 32, 32, 0)
$imagehot[5] = LoadImg("icons\movies_h.ico", 32, 32, 0)
$imagedisabled[5] = LoadImg("icons\movies_d.ico", 32, 32, 0)

$imagenormal[6] = LoadImg("icons\new archive.ico", 32, 32, 0)
$imagehot[6] = LoadImg("icons\new archive_h.ico", 32, 32, 0)
$imagedisabled[6] = LoadImg("icons\new archive_d.ico", 32, 32, 0)

$imagenormal[7] = LoadImg("icons\new doc.ico", 32, 32, 0)
$imagehot[7] = LoadImg("icons\new doc_h.ico", 32, 32, 0)
$imagedisabled[7] = LoadImg("icons\new doc_d.ico", 32, 32, 0)

$imagenormal[8] = LoadImg("icons\refresh.ico", 32, 32, 0)
$imagehot[8] = LoadImg("icons\refresh_h.ico", 32, 32, 0)
$imagedisabled[8] = LoadImg("icons\refresh_d.ico", 32, 32, 0)

$imagenormal[9] = LoadImg("icons\search.ico", 32, 32, 0)
$imagehot[9] = LoadImg("icons\search_h.ico", 32, 32, 0)
$imagedisabled[9] = LoadImg("icons\search_d.ico", 32, 32, 0)

$imagenormal[10] = LoadImg("icons\stop.ico", 32, 32, 0)
$imagehot[10] = LoadImg("icons\stop_h.ico", 32, 32, 0)
$imagedisabled[10] = LoadImg("icons\stop_d.ico", 32, 32, 0)

$imagenormal[11] = LoadImg("icons\music 2.ico", 32, 32, 0)
$imagehot[11] = LoadImg("icons\music 2_h.ico", 32, 32, 0)
$imagedisabled[11] = LoadImg("icons\music 2_d.ico", 32, 32, 0)

;- process ProGUI Windows event messages here
Func ProGUI_EventCallback($hwnd, $message, $wParam, $lParam)

  Select

    ; handle selection of toolbar items
    Case $message = $WM_COMMAND

      If Hword($wParam) = 0 Then ; is an ID Then

        $ButtonID = LWord($wParam)

        ConsoleWrite($ButtonID&@CRLF) ; display selected toolbar item

      EndIf

  EndSelect

  Return $GUI_RUNDEFMSG

EndFunc

; creates a window
Func Open_Window_0()

  Global $Window_0 = GUICreate("ToolBarExExample 1", 800, 500, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX))

  ; create popupmenu
  SetMenuExImageSize(32, 32)
  $popupmenu = CreatePopupMenuEx($PopupMenu_0, $UISTYLE_WHIDBEY)
  MenuItemEx($PopupMenu_0, "Test menu", $imagenormal[4], $imagehot[4], $imagedisabled[4], 0)
  MenuItemEx($PopupMenu_0, "Another one!", $imagenormal[5], $imagehot[5], $imagedisabled[5], 0)

  ; create toolbar
  $toolbar = CreateToolBarEx($TOOLBAR_0, $Window_0, 32, 32, $TBSTYLE_WRAPABLE)

  ToolBarImageButtonEx(0, "Preferences", $imagenormal[0], $imagehot[0], 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  SelectToolbarExButton($TOOLBAR_0, 0, 1)
  ToolBarImageButtonEx(20, "\sBack", $imagenormal[1], $imagehot[1], 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  ToolBarImageButtonEx(3, "\b\c842059c\c10bf50o\c59aa10l\c345512o\caa2066u\c005f00r", $imagenormal[2], $imagehot[2], 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECKGROUP))
  ToolBarImageButtonEx(4, "", 0, 0, 0, $BTNS_SEP)
  ToolBarImageButtonEx(5, "Computer", $imagenormal[3], $imagehot[3], 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(6, "Copy Document", $imagenormal[4], $imagehot[4], 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(7, "\iMovies", $imagenormal[5], $imagehot[5], 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(8, "Archive", $imagenormal[6], $imagehot[6], 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(9, "\uNew\u Document", $imagenormal[7], $imagehot[7], 0, $BTNS_AUTOSIZE)
  ToolBarDropdownImageButtonEx(10, $popupmenu, "Refresh", $imagenormal[8], $imagehot[8], 0, BitOR($BTNS_AUTOSIZE, $BTNS_WHOLEDROPDOWN))
  ToolBarImageButtonEx(11, "", 0, 0, 0, $BTNS_SEP)
  ToolBarImageButtonEx(12, "Search", $imagenormal[9], $imagehot[9], 0, BitOR($BTNS_AUTOSIZE, $BTNS_CHECK))
  ToolBarImageButtonEx(13, "\bStop", $imagenormal[10], $imagehot[10], 0, $BTNS_AUTOSIZE)
  ToolBarImageButtonEx(14, "Music", $imagenormal[11], $imagehot[11], 0, $BTNS_AUTOSIZE)

  DisableToolbarExButton($TOOLBAR_0, 6, 1)
  DisableToolbarExButton($TOOLBAR_0, 7, 1)

  ; free loaded icons as we don't need them anymore
  For $n = 0 To 11
    FreeImg($imagenormal[$n])
    FreeImg($imagehot[$n])
    FreeImg($imagedisabled[$n])
  Next

  ; attach our events callback for processing Windows ProGUI messages
  GUIRegisterMsg($WM_COMMAND, "ProGUI_EventCallback")
  GUIRegisterMsg($WM_SIZE, "ProGUI_EventCallback")
  GUIRegisterMsg($REBAR_UPDATED, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_CLICK, "ProGUI_EventCallback")
  GUIRegisterMsg($TCX_LINK_HOVER, "ProGUI_EventCallback")

EndFunc

Open_Window_0() ; create window
GUISetState(@SW_SHOW) ; show our newly created window

; enter main event loop
Do

  $Event = GUIGetMsg()

Until $Event = $GUI_EVENT_CLOSE
